#include "stdafx.h"
#include "OGLView.h"
#include "OGLCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//*****************************************************************************
// OpenGL reusable View class to encapsulate Views with OpenGL graphs
// By G.Bavestrelli                     Copyright Techint S.p.A. 1998
//*****************************************************************************

IMPLEMENT_DYNAMIC(COpenGLView, CView)

BEGIN_MESSAGE_MAP(COpenGLView, CView)
    ON_WM_SIZE()
    ON_WM_CREATE()
END_MESSAGE_MAP()

COpenGLView::COpenGLView(COpenGLCtrl & OpenGLCtrl)
            :m_OpenGLCtrl(OpenGLCtrl) 
{
}
   
COpenGLView::~COpenGLView()
{
}

BOOL COpenGLView::PreCreateWindow(CREATESTRUCT& cs)
{
    cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
    return CView::PreCreateWindow(cs);
}

void COpenGLView::OnSize(UINT nType, int cx, int cy) 
{
    CView::OnSize(nType, cx, cy);
    
    // Fill entire window with OpenGLCtrl
    if (cx && cy && m_OpenGLCtrl.m_hWnd)
          m_OpenGLCtrl.MoveWindow(0,0,cx,cy,TRUE);
    
}

BOOL COpenGLView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
    // Let OpenGLCtrl handle command messages first
    if (m_OpenGLCtrl.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))    
        return TRUE;
    else
        return CView::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

int COpenGLView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    if (CView::OnCreate(lpCreateStruct) == -1)
        return -1;
    
    CRect Rect;
    GetClientRect(&Rect);

    // Create the OpenGLCtrl
    if (!m_OpenGLCtrl.Create("MyOpenGL","MyOpenGL",
                             WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
                             Rect,this,1,NULL))
    {
        TRACE0("Failed creating COpenGLCtrl window in COpenGLView\n");
        return -1;
    }
    
    return 0;
}

