// File MyGraph.cpp

#include "stdafx.h"
#include "oglctrl.h" 
#include "MyGraph.h"

CMyGraph::CMyGraph()
         :RotationX(0),RotationY(0)
{
}

BEGIN_MESSAGE_MAP(CMyGraph,COpenGLCtrls)
    ON_WM_LBUTTONDOWN()
    ON_WM_LBUTTONUP()
    ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

void CMyGraph::OnCreateRC()
{
    glClearColor(0.0f,0.0f,0.0f,0.0f);
    glClearDepth(1.0f);
    glEnable(GL_DEPTH_TEST);
}

void CMyGraph::OnRender()
{
    // Rotate the model
    glRotatef((GLfloat)RotationY,0.0f,1.0f,0.0f);
    glRotatef((GLfloat)RotationX,1.0f,0.0f,0.0f);
    
    // Draw the color pyramid
    glBegin(GL_TRIANGLE_FAN);
       glColor3f(1.0f,1.0f,1.0f);
       glVertex3f(0.0f,1.0f,0.0f);
       glColor3f(1.0f,0.0f,0.0f);
       glVertex3f(-1.0f,0.0f,0.0f);
       glColor3f(1.0f,1.0f,0.0f);
       glVertex3f(0.0f,0.0f,1.0f);
       glColor3f(0.0f,1.0f,0.0f);
       glVertex3f(1.0f,0.0f,0.0f);
       glColor3f(0.0f,0.0f,1.0f);
       glVertex3f(0.0f,0.0f,-1.0f);
       glColor3f(1.0f,0.0f,0.0f);
       glVertex3f(-1.0f,0.0f,0.0f);
    glEnd();

    // Show a sphere (if it works...)
    // This call will cause a memory leak on termination
    auxWireSphere(1);
}

void CMyGraph::OnDestroyRC()
{
    TRACE0("The memory leak is caused by the call to auxWireSphere\n");
}

void CMyGraph::OnViewport(int cx, int cy)
{
    glViewport(0,0,cx,cy);
}

void CMyGraph::OnViewing()
{
    gluLookAt(2,2,2,0,0,0,0,1,0);
}

void CMyGraph::OnProjection(GLdouble AspectRatio)
{
    gluPerspective(45,AspectRatio,1,10);
}

void CMyGraph::OnLButtonDown(UINT nFlags, CPoint point)
{
    SetCapture();
    MouseDown=point;
    SetCursor(LoadCursor(NULL,IDC_SIZEALL));
}

void CMyGraph::OnLButtonUp(UINT nFlags, CPoint point)
{
    ReleaseCapture();
}

void CMyGraph::OnMouseMove(UINT nFlags, CPoint point)
{
    CRect R;
    GetClientRect(&R);

    if (!GetCapture() || R.IsRectEmpty()) 
        return;

    // Implement wild rotation 
    RotationY=(RotationY+((point.x-MouseDown.x)*360/R.Width()))%360; 
    RotationX=(RotationX+((point.y-MouseDown.y)*360/R.Height()))%360; 

    MouseDown=point;
    InvalidateRect(NULL);
}
    